#include <stdio.h>
#include <string.h>

#include <Alert.h>
#include <Application.h>
#include <Bitmap.h>
#include <Screen.h>
#include <String.h>
#include <View.h>
#include <Window.h>


// main
int
main(int argc, char* argv[])
{
	BApplication app("application/x.vnd-YellowBites.throughput");
	BRect r(50.0, 50.0, 249.0, 249.0);
	BWindow* window = new BWindow(r, "throughput", B_TITLED_WINDOW,
								  B_ASYNCHRONOUS_CONTROLS);

	r.OffsetTo(0.0, 0.0);

	BScreen screen(window);

	BBitmap* bitmap = new BBitmap(r, 0, screen.ColorSpace());
	memset(bitmap->Bits(), 0, bitmap->BitsLength());

	BView* view = new BView(r, "test", B_FOLLOW_NONE, B_WILL_DRAW);
	view->SetViewColor(B_TRANSPARENT_32_BIT);

	window->AddChild(view);
	window->Show();

	if (window->Lock()) {
		bigtime_t now = system_time();
		int32 n = 400;
		for (int32 i = 0; i < n; i++) {
			view->DrawBitmap(bitmap);
			view->Sync();
		}
		now = system_time() - now;
		window->Unlock();

		BString string;
		string << "drawing "
			   << n
			   << " bitmaps ("
			   << bitmap->Bounds().IntegerWidth() + 1
			   << "x"
			   << bitmap->Bounds().IntegerHeight() + 1
			   << "):\n"
			   << now 
			   << " µs\n\nthroughput:\n"
			   << (float)(((((float)(n * bitmap->BitsLength())) / 1024.0) / 1024.0) / ((float)now / 1000000.0))
			   << " Mb/s";

		printf("%s\n", string.String());

		BAlert* alert = new BAlert("report", string.String(), "Ok");
		alert->Go();
	}
	delete bitmap;
	return 0;
}
